{ 030301a4b.pas                                                             }
{ 2003-03-01 programmeerimisvistluse algajate 4. lesande lahendus         }
{    AKNAD                                                                  }
{ Kristo Tammeoja                                                           }
{ Testitud: FPC 1.0.6/Win32                                                 }

{ See on ebaefektiivne lahendus, mis jb suuremates testides ajahtta.     }
{ Turbo Pascali all oleks vaja mluhaldusega eraldi tegeleda...             }

Const
 SisFail = 'AKEN.SIS'; ValFail = 'AKEN.VAL';

 MAX_N = 100;

Type
 t_ristkylik = Record
  x1, y1, x2, y2 : Longint;
 End;

Var
 sfail, vfail : Text;

 {Failist loetud andmed}
 N : Longint;
 peaaken : t_ristkylik;
 aken : Array [1..MAX_N] of t_ristkylik;

 aknaid : Longint; {alamaknaid prast nendede likamist}

 vastus : Longint;

 {kogu ekraan pikselite massiivina}
 ekraan : Array [0..799, 0..599] of Boolean;



{-------------- ABIMEETODID ----------------}


Function Max (a, b : Longint) : Longint;
Begin
 If a>b Then Max := a Else Max := b;
End;


Function Min (a, b : Longint) : Longint;
Begin
 If a<b Then Min := a Else Min := b;
End;


{-------------------------------------------}


Procedure LoeAndmed;
Var l : Longint;
Begin
 Assign (sfail, SisFail); Reset (sfail);

 {Peaaken}
 ReadLn (sfail, peaaken.x1, peaaken.y1, peaaken.x2, peaaken.y2);

 {Alamaknad}
 ReadLn (sfail, N);
 For l := 1 To N Do
  ReadLn (sfail, aken[l].x1, aken[l].y1, aken[l].x2, aken[l].y2);

 Close (sfail);
End;



Procedure NormaliseeriKoordinaadid;
Var l : Longint;

 Procedure Normaliseeri (var rk : t_ristkylik);
 Begin
  Inc (rk.x2); Inc (rk.y2);
 End;

Begin
 Normaliseeri (peaaken);

 For l := 1 To N Do
  Normaliseeri (aken[l]);
End;



Procedure LoikaAknaid;
Var l : Longint;

 Procedure Loika (var rk : t_ristkylik);
 Begin
  rk.x1 := Max (rk.x1, peaaken.x1);
  rk.y1 := Max (rk.y1, peaaken.y1);
  rk.x2 := Min (rk.x2, peaaken.x2);
  rk.y2 := Min (rk.y2, peaaken.y2);
 End;

Begin
 aknaid := 0;

 For l := 1 To N Do Begin
  Loika (aken[l]);

  If (aken[l].x1<aken[l].x2) And (aken[l].y1<aken[l].y2) Then Begin
   {Kui akna pindala ji prast likamist nullist suuremaks}
   Inc (aknaid);
   aken[aknaid] := aken[l];
  End;
 End;

End;



{---------------- LAHENDAMINE ----------------}


Function AlamakendePindala : Longint;
Var i, j, k : Longint; c : Longint;
Begin
 For j := 0 To 799 Do
  For k := 0 to 599 Do
   ekraan[j,k] := False;

 For i := 1 To aknaid Do
  For j := aken[i].x1 To aken[i].x2-1 Do
   For k := aken[i].y1 To aken[i].y2-1 Do
    ekraan[j,k] := True;

 c := 0;
 For j := peaaken.x1 To peaaken.x2-1 Do
  For k := peaaken.y1 To peaaken.y2-1 Do
   If ekraan[j,k] Then inc(c);

 AlamakendePindala := c;
End;



Procedure ArvutaVastus;
Begin
 vastus := (peaaken.x2-peaaken.x1)*(peaaken.y2-peaaken.y1) -
           AlamakendePindala;
End;


{---------------------------------------------}


Procedure KirjutaVastus;
Begin
 Assign (vfail, ValFail); Rewrite (vfail);
 WriteLn (vfail, vastus);
 Close (vfail);
End;



Begin
 LoeAndmed;
 NormaliseeriKoordinaadid;
 LoikaAknaid;

 ArvutaVastus;

 KirjutaVastus;
End.
