{ 030301a3.pas                                                              }
{ 2003-03-01 programmeerimisvistluse algajate 3. lesande lahendus         }
{    MOSAIIK                                                                }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'MOSA.SIS';
   valf = 'MOSA.VAL';

const
   maxc = 5;
   maxr = 10;
   maxv = 10;
   maxk = maxr * maxv;

type
   kild = record
      c1, c2, c3, c4 : integer;
   end;

var
   f : text;                                           { sisend/vljundfail }
   c, r, v : integer;                       { vrvide arv, mosaiigi mtmed }
   k : array [1..maxk] of kild;                       { olemasolevad killud }

   kilde : array [0..maxc, 0..maxc, 0..maxc, 0..maxc] of integer;
   par : array [1..maxr, 0..maxv] of integer;
   alu : array [0..maxr, 1..maxv] of integer;

function otsi(rr, vv : integer) : boolean;
var c2, c3 : integer;
begin
  otsi := false;
  if rr < r then begin                                 { mitte viimane rida }
     if vv < v then begin                             { mitte viimane veerg }
        for c2 := 1 to c do
           for c3 := 1 to c do
              if kilde[alu[rr - 1, vv], c2, c3, par[rr, vv - 1]] > 0 then begin
                 par[rr, vv] := c2;
                 alu[rr, vv] := c3;
                 dec(kilde[alu[rr - 1, vv], c2, c3, par[rr, vv - 1]]);
                 if otsi(rr, vv + 1) then begin
                    otsi := true; exit;
                 end;
                 inc(kilde[alu[rr - 1, vv], c2, c3, par[rr, vv - 1]]);
              end;
     end else begin                 { viimane veerg, parem serv fikseeritud }
        for c3 := 1 to c do
           if kilde[alu[rr - 1, vv], 0, c3, par[rr, vv - 1]] > 0 then begin
              par[rr, vv] := 0;
              alu[rr, vv] := c3;
              dec(kilde[alu[rr - 1, vv], 0, c3, par[rr, vv - 1]]);
              if otsi(rr + 1, 1) then begin
                 otsi := true; exit;
              end;
              inc(kilde[alu[rr - 1, vv], 0, c3, par[rr, vv - 1]]);
           end;
     end;
  end else begin                   { viimane rida, alumine serv fikseeritud }
     if vv < v then begin                             { mitte viimane veerg }
        for c2 := 1 to c do
           if kilde[alu[rr - 1, vv], c2, 0, par[rr, vv - 1]] > 0 then begin
              par[rr, vv] := c2;
              alu[rr, vv] := 0;
              dec(kilde[alu[rr - 1, vv], c2, 0, par[rr, vv - 1]]);
              if otsi(rr, vv + 1) then begin
                 otsi := true; exit;
              end;
              inc(kilde[alu[rr - 1, vv], c2, 0, par[rr, vv - 1]]);
           end;
     end else begin                 { viimane veerg, parem serv fikseeritud }
        if kilde[alu[rr - 1, vv], 0, 0, par[rr, vv - 1]] > 0 then begin
           par[rr, vv] := 0;
           alu[rr, vv] := 0;
           dec(kilde[alu[rr - 1, vv], 0, 0, par[rr, vv - 1]]);
           otsi := true; exit;
        end;
     end;
  end;
end;

function indeks(var rr, vv : integer) : integer;
var i : integer;
begin
   for i := 1 to r * v do
      if (k[i].c1 = alu[rr - 1, vv]) and (k[i].c2 = par[rr, vv]) and
         (k[i].c3 = alu[rr, vv]) and (k[i].c4 = par[rr, vv - 1]) then begin
         k[i].c1 := -1; k[i].c2 := -1; k[i].c3 := -1; k[i].c4 := -1;
         indeks := i;
         exit;
      end;
   indeks := -1;
end;

procedure valjund(var f : text);
var i, j : integer;
begin
   for i := 1 to r do begin
      for j := 1 to v do begin
         if j > 1 then
            write(f, ' ');
         write(f, indeks(i, j));
      end;
      writeln(f);
   end;
end;

var
   i, c1, c2, c3, c4 : integer;
begin
   assign(f, sisf); reset(f);
   readln(f, c);
   readln(f, r, v);
   for i := 1 to r * v do
      readln(f, k[i].c1, k[i].c2, k[i].c3, k[i].c4);
   close(f);
   
   for c1 := 0 to c do
      for c2 := 0 to c do
         for c3 := 0 to c do
            for c4 := 0 to c do
               kilde[c1, c2, c3, c4] := 0;
   for i := 1 to r * v do
      inc(kilde[k[i].c1, k[i].c2, k[i].c3, k[i].c4]);

   for i := 1 to r do
     par[i, 0] := 0;
   for i := 1 to v do
     alu[0, i] := 0;

   assign(f, valf); rewrite(f);
   if not otsi(1, 1) then begin
      writeln(f, 'Lahend puudub');
   end else begin
      valjund(f);
   end;
   close(f);
end.
