{ 030301e2.pas                                                              }
{ 2003-03-01 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{    MOSAIIK                                                                }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'MOSA.SIS';
   valf = 'MOSA.VAL';

const
   maxc = 5;
   maxx = (maxc + 1) * (maxc + 1) * (maxc + 1) * (maxc + 1);
   maxr = 10;
   maxv = 10;

var
   f : text;                                           { sisend/vljundfail }
   c, r, v : integer;                       { vrvide arv, mosaiigi mtmed }

   kilde : array [0..maxx] of integer;
   par : array [1..maxr, 0..maxv] of integer;
   alu : array [0..maxr, 1..maxv] of integer;

function indeks(c1, c2, c3, c4 : integer) : integer;
   function ind(c1, c2, c3, c4 : integer) : integer;
   begin
      ind := ((c1 * (c + 1) + c2) * (c + 1) + c3) * (c + 1) + c4;
   end;
var x : integer;
begin
   x := maxx;
   if ind(c1, c2, c3, c4) < x then x := ind(c1, c2, c3, c4);
   if ind(c2, c3, c4, c1) < x then x := ind(c2, c3, c4, c1);
   if ind(c3, c4, c1, c2) < x then x := ind(c3, c4, c1, c2);
   if ind(c4, c1, c2, c3) < x then x := ind(c4, c1, c2, c3);
   if ind(c4, c3, c2, c1) < x then x := ind(c4, c3, c2, c1);
   if ind(c3, c2, c1, c4) < x then x := ind(c3, c2, c1, c4);
   if ind(c2, c1, c4, c3) < x then x := ind(c2, c1, c4, c3);
   if ind(c1, c4, c3, c2) < x then x := ind(c1, c4, c3, c2);
   indeks := x;
end;

function otsi(rr, vv : integer) : boolean;
var c2, c3, x : integer;
begin
  otsi := false;
  if rr < r then begin                                 { mitte viimane rida }
     if vv < v then begin                             { mitte viimane veerg }
        for c2 := 1 to c do
           for c3 := 1 to c do begin
              x := indeks(alu[rr - 1, vv], c2, c3, par[rr, vv - 1]);
              if kilde[x] > 0 then begin
                 par[rr, vv] := c2;
                 alu[rr, vv] := c3;
                 dec(kilde[x]);
                 if otsi(rr, vv + 1) then begin
                    otsi := true; exit;
                 end;
                 inc(kilde[x]);
              end;
           end;
     end else begin                 { viimane veerg, parem serv fikseeritud }
        for c3 := 1 to c do begin
           x := indeks(alu[rr - 1, vv], 0, c3, par[rr, vv - 1]);
           if kilde[x] > 0 then begin
              par[rr, vv] := 0;
              alu[rr, vv] := c3;
              dec(kilde[x]);
              if otsi(rr + 1, 1) then begin
                 otsi := true; exit;
              end;
              inc(kilde[x]);
           end;
        end;
     end;
  end else begin                   { viimane rida, alumine serv fikseeritud }
     if vv < v then begin                             { mitte viimane veerg }
        for c2 := 1 to c do begin
           x := indeks(alu[rr - 1, vv], c2, 0, par[rr, vv - 1]);
           if kilde[x] > 0 then begin
              par[rr, vv] := c2;
              alu[rr, vv] := 0;
              dec(kilde[x]);
              if otsi(rr, vv + 1) then begin
                 otsi := true; exit;
              end;
              inc(kilde[x]);
           end;
        end;
     end else begin                 { viimane veerg, parem serv fikseeritud }
        x := indeks(alu[rr - 1, vv], 0, 0, par[rr, vv - 1]);
        if kilde[x] > 0 then begin
           par[rr, vv] := 0;
           alu[rr, vv] := 0;
           dec(kilde[x]);
           otsi := true; exit;
        end;
     end;
  end;
end;

procedure valjund(var f : text);
var i, j : integer;
begin
   for i := 1 to r do
      for j := 1 to v do
         writeln(f, alu[i - 1, j], ' ', par[i, j], ' ',
            alu[i, j], ' ', par[i, j - 1]);
end;

var
   i, c1, c2, c3, c4 : integer;
begin
   for i := 0 to maxx do
      kilde[i] := 0;

   assign(f, sisf); reset(f);
   readln(f, c);
   readln(f, r, v);
   for i := 1 to r * v do begin
      readln(f, c1, c2, c3, c4);
      inc(kilde[indeks(c1, c2, c3, c4)]);
   end;
   close(f);

   for i := 1 to r do
     par[i, 0] := 0;
   for i := 1 to v do
     alu[0, i] := 0;
   assign(f, valf); rewrite(f);
   if not otsi(1, 1) then begin
      writeln(f, 'Lahend puudub');
   end else begin
      valjund(f);
   end;
   close(f);
end.
