{ kontroll.pas                                                              }
{ 2003-03-01 programmeerimisvistluse algajate 3. lesande tester           }
{    MOSAIIK                                                                }
{ Ahto Truu                                                                 }

const
   maxc = 5;
   maxr = 10;
   maxv = 10;
   maxk = maxr * maxv;

type
   kild = record
      c1, c2, c3, c4 : integer;
   end;

var
   f : text;
   c, r, v : integer;
   k : array [1..maxk] of kild;
   kk : array [1..maxk] of boolean;

   par : array [1..maxr, 0..maxv] of integer;
   alu : array [0..maxr, 1..maxv] of integer;

   i, j, u : integer;

begin
   if paramcount <> 2 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, c);
   readln(f, r, v);
   for i := 1 to r * v do begin
      readln(f, k[i].c1, k[i].c2, k[i].c3, k[i].c4);
      kk[i] := false;
   end;
   close(f);

   for i := 1 to r do
     par[i, 0] := 0;
   for j := 1 to v do
     alu[0, j] := 0;

   { loeme vljundandmed }
   assign(f, paramstr(2)); reset(f);
   for i := 1 to r do begin
      for j := 1 to v do begin
         if seekeoln(f) then begin
            writeln('Liiga lhike rida ', i);
            halt(1);
         end;
         read(f, u);
         if (u < 1) or (u > r * v) then begin
            writeln('Lubamatu killu number ', u);
            halt(1);
         end;
         if k[u].c1 <> alu[i - 1, j] then begin
            writeln('Kild kohal [', i, ', ', j, '] ei sobi lemise naabriga');
            halt(1);
         end;
         par[i, j] := k[u].c2;
         alu[i, j] := k[u].c3;
         if k[u].c4 <> par[i, j - 1] then begin
            writeln('Kild kohal [', i, ', ', j, '] ei sobi vasaku naabriga');
            halt(1);
         end;
         if kk[u] then begin
            writeln('Korduvalt kasutatud kild ', u);
         end;
         kk[u] := true;
      end;
      if not seekeoln(f) then begin
         writeln('Liiga pikk rida ', i);
      end;
      readln(f);
   end;
   if not seekeof(f) then begin
      writeln('Liigsed read vljundfaili lpus');
   end;
   close(f);

   for i := 1 to r do
     if par[i, v] <> 0 then begin
        writeln('Kild kohal [', i, ', ', v, '] ei sobi parema naabriga');
        halt(1);
     end;
   for j := 1 to v do
     if alu[r, j] <> 0 then begin
        writeln('Kild kohal [', r, ', ', j, '] ei sobi alumise naabriga');
        halt(1);
     end;

   writeln('Korras');
end.
