{ kontroll.pas                                                              }
{ 2003-03-01 programmeerimisvistluse edasijudnute 2. lesande tester      }
{    MOSAIIK                                                                }
{ Ahto Truu                                                                 }

const
   maxc = 5;
   maxx = (maxc + 1) * (maxc + 1) * (maxc + 1) * (maxc + 1);
   maxr = 10;
   maxv = 10;

var
   f : text;
   c, r, v : integer;
   k : array [0..maxx] of integer;
   kk : array [0..maxx] of boolean;

   par : array [1..maxr, 0..maxv] of integer;
   alu : array [0..maxr, 1..maxv] of integer;

   i, j, x : integer;
   c1, c2, c3, c4 : integer;

function indeks(c1, c2, c3, c4 : integer) : integer;
   function ind(c1, c2, c3, c4 : integer) : integer;
   begin
      ind := ((c1 * (c + 1) + c2) * (c + 1) + c3) * (c + 1) + c4;
   end;
var x : integer;
begin
   x := maxx;
   if ind(c1, c2, c3, c4) < x then x := ind(c1, c2, c3, c4);
   if ind(c2, c3, c4, c1) < x then x := ind(c2, c3, c4, c1);
   if ind(c3, c4, c1, c2) < x then x := ind(c3, c4, c1, c2);
   if ind(c4, c1, c2, c3) < x then x := ind(c4, c1, c2, c3);
   if ind(c4, c3, c2, c1) < x then x := ind(c4, c3, c2, c1);
   if ind(c3, c2, c1, c4) < x then x := ind(c3, c2, c1, c4);
   if ind(c2, c1, c4, c3) < x then x := ind(c2, c1, c4, c3);
   if ind(c1, c4, c3, c2) < x then x := ind(c1, c4, c3, c2);
   indeks := x;
end;

begin
   if paramcount <> 2 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;

   for i := 0 to maxx do begin
      k[i] := 0;
      kk[i] := false;
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, c);
   readln(f, r, v);
   for i := 1 to r * v do begin
      readln(f, c1, c2, c3, c4);
      x := indeks(c1, c2, c3, c4);
      inc(k[x]);
      kk[x] := true;
   end;
   close(f);

   for i := 1 to r do
     par[i, 0] := 0;
   for j := 1 to v do
     alu[0, j] := 0;

   { loeme vljundandmed }
   assign(f, paramstr(2)); reset(f);
   for i := 1 to r do begin
      for j := 1 to v do begin
         read(f, c1, c2, c3, c4);
         if not seekeoln(f) then begin
            writeln('Liigsed smbolid rea lpus ', i);
         end;
         readln(f);

         if (c1 < 0) or (c1 > c) then begin
            writeln('Lubamatu vrv ', c1);
            halt(1);
         end;
         if (c2 < 0) or (c2 > c) then begin
            writeln('Lubamatu vrv ', c2);
            halt(1);
         end;
         if (c3 < 0) or (c3 > c) then begin
            writeln('Lubamatu vrv ', c3);
            halt(1);
         end;
         if (c4 < 0) or (c4 > c) then begin
            writeln('Lubamatu vrv ', c4);
            halt(1);
         end;

         if c1 <> alu[i - 1, j] then begin
            writeln('Kild kohal [', i, ', ', j, '] ei sobi lemise naabriga');
            halt(1);
         end;
         par[i, j] := c2;
         alu[i, j] := c3;
         if c4 <> par[i, j - 1] then begin
            writeln('Kild kohal [', i, ', ', j, '] ei sobi vasaku naabriga');
            halt(1);
         end;

         x := indeks(c1, c2, c3, c4);
         if not kk[x] then begin
            writeln('Tundmatu kild ', c1, c2, c3, c4);
         end;
         if k[x] = 0 then begin
            writeln('Korduvalt kasutatud kild ', c1, c2, c3, c4);
         end else
            dec(k[x]);
      end;
   end;
   if not seekeof(f) then begin
      writeln('Liigsed read vljundfaili lpus');
   end;
   close(f);

   for i := 1 to r do
     if par[i, v] <> 0 then begin
        writeln('Kild kohal [', i, ', ', v, '] ei sobi parema naabriga');
        halt(1);
     end;
   for j := 1 to v do
     if alu[r, j] <> 0 then begin
        writeln('Kild kohal [', r, ', ', j, '] ei sobi alumise naabriga');
        halt(1);
     end;

   writeln('Korras');
end.
